## How to Verify the Beluga Development

The following instructions were tested on an Arch Linux System, though most steps should carry over to a MacOS System as well.

### Preparing the Execution Environment

First of all, you need the latest version of `opam` installed (from your OS package repository). At the time of writing this was `2.0.3`.

Make sure that you are working with an OCaml compiler at version `4.05.0`. Use `opam switch` to list available environments/OCaml compilers on your system. When a suitable switch exists, simply select it with, e.g.,

```
opam switch 4.05.0`
```
Otherwise you first need to create it with the following command.

```
opam switch create 4.05.0
```

Make sure that your opam environment is updated correctly. Simply follow the on-screen instructions after changing to a different switch. This usually requires executing `eval $(opam env)` in the active terminal.

Check your installed opam packages with `opam list -i`, and verify you have at least the following (else isntall in the switch with `opam install <PKG>`):

```
- ocamlfind
- extlib-compat
- ulex
```

### Install Beluga

Now install Beluga from source. We need a commit that is `e7d538a4261e8dc10b2385a80f90a763c0e467c1` or newer. The mentioned commit does not appear to compile any longer but the `master` version at the time of writing (`285dd31c567b9d3ac11450b561161353248d1e4a`) appears to be working.

```
git clone https://github.com/Beluga-lang/Beluga.git <BELUGADIR>
cd <BELUGADIR>
make
```

### Check the Proof Script

To check the development, simply run
```
<PATH-TO-BELUGADIR>/bin/beluga equi.bel
```
which should report successfull type reconstruction and compilation.

It is also possible to work within emacs. To this end, add the follwoing to your `.emacs` file, then restart emacs and open the file `equi.bel`. Compilation is triggered with `CTRL-C CTRL-C`.

```
(add-to-list 'load-path "<PATH-TO-BELUGADIR>/tools/")
(load "beluga-mode.el")
```
